# ################################################################################
# HSE RELEASE AUTOMATION TOOLS - Generic CI Script
# ################################################################################

# include the project-specific variable definitions
include:
  - local: 'rat.yml'

# predefined environment variables (see https://docs.gitlab.com/ee/ci/variables/README.html)
variables: 
    #     CI_PROJECT_DIR				The full path where the repository is cloned and where the job is run.
    #     CI_PROJECT_ID					The unique id of the current project that GitLab CI uses internally
    #     CI_PROJECT_NAME				The project name that is currently being built (actually it is project folder name)
    #     CI_PROJECT_NAMESPACE			The project namespace (username or groupname) that is currently being built
    #     CI_PROJECT_PATH				The namespace with project name
    #     CI_PROJECT_PATH_SLUG			$CI_PROJECT_PATH lowercased and with everything except 0-9 and a-z replaced with -. Use in URLs and domain names.
    #     GITLAB_USER_EMAIL				The email of the user who started the job

    # Taken from https://docs.gitlab.com/ee/ci/git_submodules.html
    GIT_SUBMODULE_STRATEGY: recursive


# ################################################################################
# HSE RELEASE AUTOMATION TOOLS - GitLab Shared Group Variables
# ################################################################################
    #RAT_EMAIL_SERVER
    #RAT_EMAIL_ADDR
    #RAT_EMAIL_USER
    #RAT_EMAIL_PASSWORD


# ################################################################################
# STAGES  
# ################################################################################
stages:
    - analyze
    - document
    - sourcedist
    - teardown

# ################################################################################
# WORKFLOW RULES - these apply to the whole pipeline (i.e. all jobs)
# ################################################################################
workflow:
    rules:
        - if: '$CI_COMMIT_TAG =~ /^v[0-9]+\.[0-9]+\..+$/'
          when: always


# ################################################################################
# Export Source (SRC)
# ################################################################################
Analyze:
    stage: analyze
    script:
        #- g-cli --timeout 30000 -v --lv-ver 2014 "HSE RAT\rat-validatr.vi" -- "$CI_PROJECT_DIR" "$CI_PROJECT_NAMESPACE" SRC
        - g-cli --timeout 30000 -v --lv-ver 2014 "HSE RAT\rat-analyzr.vi" -- "$CI_PROJECT_DIR" "$CI_PROJECT_NAMESPACE" SRC
        #- g-cli --timeout 30000 -v --lv-ver 2014 "HSE RAT\rat-testr.vi" -- "$CI_PROJECT_DIR" "$CI_PROJECT_NAMESPACE" SRC
    artifacts:
        name: "$CI_JOB_STAGE-$CI_COMMIT_REF_NAME"
        paths:
        - artifacts/
        when: on_success
    tags:
        - "2014"
        - "labview"

Document:
    stage: document
    script:
        # run the document parser tool
        - g-cli --timeout 30000 -v --lv-ver 2014 "HSE RAT\rat-documentr.vi" -- "$CI_PROJECT_DIR" "$CI_PROJECT_NAMESPACE" SRC
        - cd "$CI_PROJECT_DIR\Documentation\DocGen\Wenglor-weCat3D-for-LabVIEW\"
        # create the HTML output
        - asciidoctor -r asciidoctor-diagram Wenglor-weCat3D-for-LabVIEW.adoc
        # create the PDF output
        - asciidoctor-pdf -r asciidoctor-diagram -a pdf-themesdir=..\hse -a pdf-theme=hse-docgen-theme.yml -a pdf-fontsdir=..\hse,GEM_FONTS_DIR Wenglor-weCat3D-for-LabVIEW.adoc
    artifacts:
        name: "$CI_JOB_STAGE-$CI_COMMIT_REF_NAME"
        paths:
            - Documentation/DocGen/Wenglor-weCat3D-for-LabVIEW/
        when: on_success
    tags:
        - "2014"
        - "labview"

SourceDistribution:
    stage: sourcedist
    script:
        # Build (execute buildspec)
        - g-cli --timeout 30000 -v --lv-ver 2014 "HSE RAT\rat-buildr.vi" -- "$CI_PROJECT_DIR" "$CI_PROJECT_NAMESPACE" SRC
        # Package (create .zip archive of project)
        - g-cli --timeout 30000 -v --lv-ver 2014 "HSE RAT\rat-packagr.vi" -- "$CI_PROJECT_DIR" "$CI_PROJECT_NAMESPACE" SRC
        # Deploy (copy package to shared folder)
        - g-cli --timeout 30000 -v --lv-ver 2014 "HSE RAT\rat-deployr.vi" -- "$CI_PROJECT_DIR" "$CI_PROJECT_NAMESPACE" SRC
    tags:
        - "2014"
        - "labview"

Teardown:
    stage: teardown
    script:
        # Build (execute buildspec)
        - g-cli --timeout 30000 --kill -v --lv-ver 2014 "HSE RAT\rat-teardown.vi" -- "$CI_PROJECT_DIR" "$CI_PROJECT_NAMESPACE" SRC
    tags:
        - "2014"
        - "labview"

